#include <SoftwareSerial.h>
#define TxPin 11                        // required by SoftwareSerial (PWM capabilities needed)
#define RxPin 10                        // required by SoftwareSerial (PWM capabilities needed)
#define el_magnet 7
#define command 8
#define debug                           // comment it out at the end of the debug phase (no Serial Monitor Tx)

SoftwareSerial BTSerial(RxPin,TxPin);   // instantiate the library

char state = ' ';                       // define input buffer as char (not empty but a blank)
const int stepPin = 4; 
const int directionPin = 2;
int OldInput = 0;                       // Variable used to transmit to app only when the input(8) changes


//-----------------------------------------------------------------------------------------------
void zatvori()
{
  digitalWrite(directionPin,HIGH);  //npr zatvori
  StepperActuate();
}     

//-----------------------------------------------------------------------------------------------
void otvori()
{
  digitalWrite(directionPin,LOW);  //npr otvori
  StepperActuate();
} 

//-----------------------------------------------------------------------------------------------
void StepperActuate()
{
  for(int x = 0; x < 50; x++) 
     {
        digitalWrite(stepPin,HIGH); 
        delayMicroseconds(500);  
        digitalWrite(stepPin,LOW); 
        delayMicroseconds(500);  
     }
}
//===============================================================================================
void setup() // done once at reset
{
  pinMode(el_magnet,OUTPUT);
  digitalWrite(el_magnet,LOW);
  pinMode(command, INPUT);
  pinMode(stepPin,OUTPUT);
  pinMode(directionPin,OUTPUT);
  // not necessary, already set into the library => pinMode(RxPin,INPUT);                 // to be connected to Tx pin of HC05
  // not necessary, already set into the library => pinMode(TxPin,OUTPUT);                // to be connected to Rx pin of HC05
  BTSerial.begin(9600);               // supposed baudrate of HC05 (38400 ?)
  Serial.begin(9600);                 // Used to echo on PC monitor the data received on BT
}

//===============================================================================================
void loop() // repeated forever
{
  // unsigned long now = 0UL;                 removed because the BT tx is done only when the input changes
  int NewInput = 0;
  char ToBeTx = '0';

  
    // now = millis();                        removed because the BT tx is done only when the input changes  
    NewInput = digitalRead(command);          // acquires the digital input
    if(NewInput != OldInput)                  // only if the new input is different with respect to the old one, then transmits to app
    {
      OldInput = NewInput;                    // Stores the New input read for the next comparison
      ToBeTx = ToBeTx + OldInput;             // converts the data read (int 0 or int 1) into a character by adding 0x30 (i.e. char '0')
      BTSerial.println(ToBeTx);               // transmits the input of pin 8 converted into a char
    }  
    // while((millis()-now) <100UL) ;         removed because the BT tx is done only when the input changes

if (BTSerial.available())                     // any char from BT ?
   {
    state = BTSerial.read();                  // yes, get it
#ifdef debug
    Serial.print("Received : ");              // echoes it on the PC screen only if the debug flag is defined (see header)
    Serial.println(state);
#endif    
    if(state=='2')                            //npr zatvori           
      {
        zatvori();
      }
          
    if(state=='3')                            //npr otvori                           
      {
        otvori();
      }
              
    if(state=='4')                       
      {
        digitalWrite(el_magnet,LOW);      
      }      
          
    if(state=='5') 
      {
        digitalWrite(el_magnet,HIGH);      
      }     
   }                                      // end if char on BT available
}                                         // end loop


